Index: tmp/org.txm.setups/nsis/Examples/nsDialogs/welcome.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/nsDialogs/welcome.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/nsDialogs/welcome.nsi	(revision 2956)
@@ -1,5 +1,6 @@
 !include MUI.nsh
 !include LogicLib.nsh
+!include nsDialogs.nsh
 !include WinMessages.nsh
 !include FileFunc.nsh
 
@@ -12,114 +13,7 @@
 
 !insertmacro MUI_LANGUAGE English
 
-!define WS_EX_CLIENTEDGE    0x00000200
 
-!define WS_CHILD            0x40000000
-!define WS_VISIBLE          0x10000000
-!define WS_DISABLED         0x08000000
-!define WS_CLIPSIBLINGS     0x04000000
-!define WS_MAXIMIZE         0x01000000
-!define WS_VSCROLL          0x00200000
-!define WS_HSCROLL          0x00100000
-!define WS_GROUP            0x00020000
-!define WS_TABSTOP          0x00010000
-
-!define ES_LEFT             0x00000000
-!define ES_CENTER           0x00000001
-!define ES_RIGHT            0x00000002
-!define ES_MULTILINE        0x00000004
-!define ES_UPPERCASE        0x00000008
-!define ES_LOWERCASE        0x00000010
-!define ES_PASSWORD         0x00000020
-!define ES_AUTOVSCROLL      0x00000040
-!define ES_AUTOHSCROLL      0x00000080
-!define ES_NOHIDESEL        0x00000100
-!define ES_OEMCONVERT       0x00000400
-!define ES_READONLY         0x00000800
-!define ES_WANTRETURN       0x00001000
-!define ES_NUMBER           0x00002000
-
-!define SS_LEFT             0x00000000
-!define SS_CENTER           0x00000001
-!define SS_RIGHT            0x00000002
-!define SS_ICON             0x00000003
-!define SS_BLACKRECT        0x00000004
-!define SS_GRAYRECT         0x00000005
-!define SS_WHITERECT        0x00000006
-!define SS_BLACKFRAME       0x00000007
-!define SS_GRAYFRAME        0x00000008
-!define SS_WHITEFRAME       0x00000009
-!define SS_USERITEM         0x0000000A
-!define SS_SIMPLE           0x0000000B
-!define SS_LEFTNOWORDWRAP   0x0000000C
-!define SS_OWNERDRAW        0x0000000D
-!define SS_BITMAP           0x0000000E
-!define SS_ENHMETAFILE      0x0000000F
-!define SS_ETCHEDHORZ       0x00000010
-!define SS_ETCHEDVERT       0x00000011
-!define SS_ETCHEDFRAME      0x00000012
-!define SS_TYPEMASK         0x0000001F
-!define SS_REALSIZECONTROL  0x00000040
-!define SS_NOPREFIX         0x00000080
-!define SS_NOTIFY           0x00000100
-!define SS_CENTERIMAGE      0x00000200
-!define SS_RIGHTJUST        0x00000400
-!define SS_REALSIZEIMAGE    0x00000800
-!define SS_SUNKEN           0x00001000
-!define SS_EDITCONTROL      0x00002000
-!define SS_ENDELLIPSIS      0x00004000
-!define SS_PATHELLIPSIS     0x00008000
-!define SS_WORDELLIPSIS     0x0000C000
-!define SS_ELLIPSISMASK     0x0000C000
-
-!define BS_PUSHBUTTON       0x00000000
-!define BS_DEFPUSHBUTTON    0x00000001
-!define BS_CHECKBOX         0x00000002
-!define BS_AUTOCHECKBOX     0x00000003
-!define BS_RADIOBUTTON      0x00000004
-!define BS_3STATE           0x00000005
-!define BS_AUTO3STATE       0x00000006
-!define BS_GROUPBOX         0x00000007
-!define BS_USERBUTTON       0x00000008
-!define BS_AUTORADIOBUTTON  0x00000009
-!define BS_PUSHBOX          0x0000000A
-!define BS_OWNERDRAW        0x0000000B
-!define BS_TYPEMASK         0x0000000F
-!define BS_LEFTTEXT         0x00000020
-!define BS_TEXT             0x00000000
-!define BS_ICON             0x00000040
-!define BS_BITMAP           0x00000080
-!define BS_LEFT             0x00000100
-!define BS_RIGHT            0x00000200
-!define BS_CENTER           0x00000300
-!define BS_TOP              0x00000400
-!define BS_BOTTOM           0x00000800
-!define BS_VCENTER          0x00000C00
-!define BS_PUSHLIKE         0x00001000
-!define BS_MULTILINE        0x00002000
-!define BS_NOTIFY           0x00004000
-!define BS_FLAT             0x00008000
-!define BS_RIGHTBUTTON      ${BS_LEFTTEXT}
-
-!define LR_DEFAULTCOLOR     0x0000
-!define LR_MONOCHROME       0x0001
-!define LR_COLOR            0x0002
-!define LR_COPYRETURNORG    0x0004
-!define LR_COPYDELETEORG    0x0008
-!define LR_LOADFROMFILE     0x0010
-!define LR_LOADTRANSPARENT  0x0020
-!define LR_DEFAULTSIZE      0x0040
-!define LR_VGACOLOR         0x0080
-!define LR_LOADMAP3DCOLORS  0x1000
-!define LR_CREATEDIBSECTION 0x2000
-!define LR_COPYFROMRESOURCE 0x4000
-!define LR_SHARED           0x8000
-
-!define IMAGE_BITMAP        0
-!define IMAGE_ICON          1
-!define IMAGE_CURSOR        2
-!define IMAGE_ENHMETAFILE   3
-
 Var DIALOG
 Var HEADLINE
 Var TEXT
@@ -202,7 +96,7 @@
 	Pop $IMAGECTL
 
 	StrCpy $0 $PLUGINSDIR\welcome.bmp
-	System::Call 'user32::LoadImage(i 0, t r0, i ${IMAGE_BITMAP}, i 0, i 0, i ${LR_LOADFROMFILE}) i.s'
+	System::Call 'user32::LoadImage(p 0, t r0, i ${IMAGE_BITMAP}, i 0, i 0, i ${LR_LOADFROMFILE})p.s'
 	Pop $IMAGE
 	
 	SendMessage $IMAGECTL ${STM_SETIMAGE} ${IMAGE_BITMAP} $IMAGE
@@ -215,9 +109,9 @@
 	nsDialogs::CreateControl STATIC ${WS_VISIBLE}|${WS_CHILD}|${WS_CLIPSIBLINGS} 0 120u 32u -130u -32u "nsDialogs is the next generation of user interfaces in NSIS. It gives the developer full control over custom pages. Some of the features include control text containing variables, callbacks directly into script functions and creation of any type of control. Create boring old edit boxes or load some external library and create custom controls with no need of creating your own plug-in.$\r$\n$\r$\nUnlike InstallOptions, nsDialogs doesn't use INI files to communicate with the script. By interacting directly with the script, nsDialogs can perform much faster without the need of costly, old and inefficient INI operations. Direct interaction also allows direct calls to functions defined in the script and removes the need of conversion functions like Io2Nsis.$\r$\n$\r$\nHit the Next button to see how it all fits into a mock directory page."
 	Pop $TEXT
 
-	SetCtlColors $DIALOG "" 0xffffff
-	SetCtlColors $HEADLINE "" 0xffffff
-	SetCtlColors $TEXT "" 0xffffff
+	SetCtlColors $DIALOG 0 0xffffff
+	SetCtlColors $HEADLINE 0 0xffffff
+	SetCtlColors $TEXT 0 0xffffff
 
 	Call HideControls
 
@@ -225,7 +119,7 @@
 
 	Call ShowControls
 
-	System::Call gdi32::DeleteObject(i$IMAGE)
+	System::Call gdi32::DeleteObject(p$IMAGE)
 
 FunctionEnd
 
@@ -257,7 +151,7 @@
 	GetFunctionAddress $0 DirChange
 	nsDialogs::OnChange $DIRECTORY $0
 
-	System::Call shlwapi::SHAutoComplete(i$DIRECTORY,i${SHACF_FILESYSTEM})
+	System::Call shlwapi::SHAutoComplete(p$DIRECTORY,i${SHACF_FILESYSTEM})
 
 	nsDialogs::CreateControl STATIC ${WS_VISIBLE}|${WS_CHILD}|${WS_CLIPSIBLINGS} 0 0 -10u 100% 10u ""
 	Pop $FREESPACE
@@ -304,7 +198,7 @@
 
 	GetDlgItem $0 $HWNDPARENT 1
 
-	System::Call user32::GetWindowText(i$DIRECTORY,t.d,i${NSIS_MAX_STRLEN})
+	System::Call user32::GetWindowText(p$DIRECTORY,t.d,i${NSIS_MAX_STRLEN})
 
 	${If} ${FileExists} $INSTDIR\makensis.exe
 		EnableWindow $0 1
Index: tmp/org.txm.setups/nsis/Examples/nsDialogs/timer.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/nsDialogs/timer.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/nsDialogs/timer.nsi	(revision 2956)
@@ -1,9 +1,11 @@
 !include LogicLib.nsh
 !include nsDialogs.nsh
+!include WinMessages.nsh
 
 Name "nsDialogs Timer Example"
 OutFile "nsDialogs Timer Example.exe"
 XPStyle on
+RequestExecutionLevel user
 
 Var DIALOG
 Var TEXT
@@ -14,10 +16,11 @@
 Var BUTTON2
 
 Page custom nsDialogsPage
+!pragma warning disable 8000 ; "Page instfiles not used, no sections will be executed!"
 
 Function OnTimer
 
-  	SendMessage $PROGBAR ${PBM_GETPOS} 0 0 $1
+	SendMessage $PROGBAR ${PBM_GETPOS} 0 0 $1
 	${If} $1 = 100
 		SendMessage $PROGBAR ${PBM_SETPOS} 0 0
 	${Else}
@@ -28,7 +31,7 @@
 
 Function OnTimer2
 
-  	SendMessage $PROGBAR2 ${PBM_GETPOS} 0 0 $1
+	SendMessage $PROGBAR2 ${PBM_GETPOS} 0 0 $1
 	${If} $1 = 100
 		SendMessage $PROGBAR2 ${PBM_SETPOS} 0 0
 	${Else}
@@ -39,10 +42,10 @@
 
 Function OnTimer3
 
-  	SendMessage $PROGBAR3 ${PBM_GETPOS} 0 0 $1
+	SendMessage $PROGBAR3 ${PBM_GETPOS} 0 0 $1
 	${If} $1 >= 100
 		${NSD_KillTimer} OnTimer3
- 		MessageBox MB_OK "Timer 3 killed"
+		MessageBox MB_OK "Timer 3 killed"
 	${Else}
 		SendMessage $PROGBAR3 ${PBM_DELTAPOS} 2 0
 	${EndIf}
@@ -82,6 +85,8 @@
 
 	${NSD_CreateProgressBar} 0u 52u 100% 12u ""
 	Pop $PROGBAR2
+	SendMessage $PROGBAR2 ${PBM_SETBARCOLOR} 0 0x0000FF ; No visual styles
+	SendMessage $PROGBAR2 ${PBM_SETSTATE} ${PBST_ERROR} 0 ; Vista+
 
 	${NSD_CreateButton} 0u 67u 100u 14u "Kill Timer 2"
 	Pop $BUTTON2
Index: tmp/org.txm.setups/nsis/Examples/nsDialogs/InstallOptions.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/nsDialogs/InstallOptions.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/nsDialogs/InstallOptions.nsi	(revision 2956)
@@ -17,7 +17,7 @@
 Function nsDialogsIO
 
 	InitPluginsDir
-	File /oname=$PLUGINSDIR\io.ini "${NSISDIR}\Examples\InstallOptions\test.ini"
+	File /oname=$PLUGINSDIR\io.ini "..\InstallOptions\test.ini"
 
 	${If} ${Cmd} `MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Test the right-to-left version?" IDYES`
 		WriteINIStr $PLUGINSDIR\io.ini Settings RTL 1
Index: tmp/org.txm.setups/nsis/Examples/bigtest.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/bigtest.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/bigtest.nsi	(revision 2956)
@@ -36,6 +36,7 @@
 LicenseData "bigtest.nsi"
 
 RequestExecutionLevel admin
+ManifestSupportedOS all
 
 ;--------------------------------
 
@@ -66,7 +67,7 @@
 Section "" ; empty string makes it hidden, so would starting with -
 
   ; write reg info
-  StrCpy $1 "POOOOOOOOOOOP"
+  StrCpy $1 "Hello World"
   DetailPrint "I like to be able to see what is going on (debug) $1"
   WriteRegStr HKLM SOFTWARE\NSISTest\BigNSISTest "Install_Dir" "$INSTDIR"
 
@@ -77,7 +78,7 @@
   SetOutPath $INSTDIR
   File /a "silent.nsi"
   CreateDirectory "$INSTDIR\MyProjectFamily\MyProject" ; 2 recursively create a directory for fun.
-  WriteUninstaller "bt-uninst.exe"
+  WriteUninstaller "$INSTDIR\bt-uninst.exe"
   
   Nop ; for fun
 
@@ -138,7 +139,7 @@
   
 SectionEnd
 
-Section "Test CreateShortCut"
+Section "Test CreateShortcut"
 
   SectionIn 1 2 3
 
@@ -148,6 +149,27 @@
 
 SectionGroup Group2
 
+!define ASSERT `!insertmacro ASSERT "${U+24}{__FILE__}" ${U+24}{__LINE__} `
+!macro ASSERT __file __line __xpr
+${__xpr} +2
+MessageBox MB_ICONSTOP `ASSERT: ${__xpr} (${__file}:${__line})`
+!macroend
+
+Section "Integer"
+IntOp $0 0xffffffff >> 31
+${ASSERT} `IntCmpU $0 -1`
+IntOp $0 0xffffffff >>> 31
+${ASSERT} `IntCmpU $0 1`
+IntOp $0 1 << 31
+${ASSERT} `IntCmpU $0 0x80000000`
+IntOp $0 0x80000000 ^ 0x40000000
+${ASSERT} `IntCmpU $0 0xC0000000`
+ClearErrors
+IntOp $0 1 / 0
+${ASSERT} `IfErrors ` ; Division by zero must set the error flag
+${ASSERT} `IntCmpU $0 0` ; Unspecified result, hopefully it's zero
+SectionEnd
+
 Section "Test Branching" 
   
   BeginTestSection:
@@ -238,10 +260,10 @@
   
   CreateDirectory "$SMPROGRAMS\Big NSIS Test"
   SetOutPath $INSTDIR ; for working directory
-  CreateShortCut "$SMPROGRAMS\Big NSIS Test\Uninstall BIG NSIS Test.lnk" "$INSTDIR\bt-uninst.exe" ; use defaults for parameters, icon, etc.
+  CreateShortcut "$SMPROGRAMS\Big NSIS Test\Uninstall BIG NSIS Test.lnk" "$INSTDIR\bt-uninst.exe" ; use defaults for parameters, icon, etc.
   ; this one will use notepad's icon, start it minimized, and give it a hotkey (of Ctrl+Shift+Q)
-  CreateShortCut "$SMPROGRAMS\Big NSIS Test\silent.nsi.lnk" "$INSTDIR\silent.nsi" "" "$WINDIR\notepad.exe" 0 SW_SHOWMINIMIZED CONTROL|SHIFT|Q
-  CreateShortCut "$SMPROGRAMS\Big NSIS Test\TheDir.lnk" "$INSTDIR\" "" "" 0 SW_SHOWMAXIMIZED CONTROL|SHIFT|Z
+  CreateShortcut "$SMPROGRAMS\Big NSIS Test\silent.nsi.lnk" "$INSTDIR\silent.nsi" "" "$WINDIR\notepad.exe" 0 SW_SHOWMINIMIZED CONTROL|SHIFT|Q
+  CreateShortcut "$SMPROGRAMS\Big NSIS Test\TheDir.lnk" "$INSTDIR\" "" "" 0 SW_SHOWMAXIMIZED CONTROL|SHIFT|Z
 
 FunctionEnd
 
Index: tmp/org.txm.setups/nsis/Examples/UserInfo/UserInfo.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/UserInfo/UserInfo.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/UserInfo/UserInfo.nsi	(revision 2956)
@@ -1,13 +1,16 @@
 Name "UserInfo.dll test"
 OutFile UserInfo.exe
+RequestExecutionLevel Highest
 
 !define REALMSG "$\nOriginal non-restricted account type: $2"
 
 Section
 	ClearErrors
 	UserInfo::GetName
-	IfErrors Win9x
+	IfErrors PluginFail
 	Pop $0
+	StrCmp $0 "" 0 +2 ; GetName can return a empty string on Win9x
+		StrCpy $0 "?"
 	UserInfo::GetAccountType
 	Pop $1
 	# GetOriginalAccountType will check the tokens of the original user of the
@@ -19,7 +22,7 @@
 	# "admin" while GetAccountType will return "user".
 	UserInfo::GetOriginalAccountType
 	Pop $2
-	StrCmp $1 "Admin" 0 +3
+	StrCmp $1 "Admin" 0 +3 ; Note: Win9x always returns "Admin"
 		MessageBox MB_OK 'User "$0" is in the Administrators group${REALMSG}'
 		Goto done
 	StrCmp $1 "Power" 0 +3
@@ -34,10 +37,8 @@
 	MessageBox MB_OK "Unknown error"
 	Goto done
 
-	Win9x:
-		# This one means you don't need to care about admin or
-		# not admin because Windows 9x doesn't either
-		MessageBox MB_OK "Error! This DLL can't run under Windows 9x!"
+	PluginFail:
+		MessageBox MB_OK "Error! Unable to call plug-in!"
 
 	done:
 SectionEnd
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI/System.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI/System.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI/System.nsh	(revision 2956)
@@ -1,25 +1,20 @@
 /*
 
-NSIS Modern User Interface - Version 1.8
-Copyright 2002-2015 Joost Verburg
+NSIS Modern User Interface - Version 1.81
+Copyright 2002-2020 Joost Verburg
 
 */
 
-!echo "NSIS Modern User Interface version 1.8 - Copyright 2002-2015 Joost Verburg"
-
-;--------------------------------
-
 !ifndef MUI_INCLUDED
+!verbose push 3
 !define MUI_INCLUDED
+!define MUI_SYSVERSION "1.81"
+!verbose pop
+!echo "NSIS Modern User Interface version ${MUI_SYSVERSION} - Copyright 2002-2020 Joost Verburg"
 
-!define MUI_SYSVERSION "1.8"
-
-!verbose push
-
-!ifndef MUI_VERBOSE
-  !define MUI_VERBOSE 3
-!endif
-
+;--------------------------------
+!verbose push 3
+!define /IfNDef MUI_VERBOSE 3
 !verbose ${MUI_VERBOSE}
 
 ;--------------------------------
@@ -129,10 +124,17 @@
     !insertmacro MUI_DEFAULT MUI_INSTFILESPAGE_COLORS "/windows"
     !insertmacro MUI_DEFAULT MUI_INSTFILESPAGE_PROGRESSBAR "smooth"
     !insertmacro MUI_DEFAULT MUI_BGCOLOR "FFFFFF"
+    !insertmacro MUI_DEFAULT MUI_TEXTCOLOR "000000"
     !insertmacro MUI_DEFAULT MUI_WELCOMEFINISHPAGE_INI "${NSISDIR}\Contrib\Modern UI\ioSpecial.ini"
     !insertmacro MUI_DEFAULT MUI_UNWELCOMEFINISHPAGE_INI "${NSISDIR}\Contrib\Modern UI\ioSpecial.ini"
     !insertmacro MUI_DEFAULT MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\win.bmp"
     !insertmacro MUI_DEFAULT MUI_UNWELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\win.bmp"
+    !if "${MUI_WELCOMEFINISHPAGE_BITMAP}" == ""
+      !error "Invalid MUI_WELCOMEFINISHPAGE_BITMAP"
+    !endif
+    !if "${MUI_UNWELCOMEFINISHPAGE_BITMAP}" == ""
+      !error "Invalid MUI_UNWELCOMEFINISHPAGE_BITMAP"
+    !endif
 
     !ifdef MUI_HEADERIMAGE
 
@@ -145,6 +147,13 @@
         !endif
       !endif
 
+      !if "${MUI_HEADERIMAGE_BITMAP}" == ""
+        !error "Invalid MUI_HEADERIMAGE_BITMAP"
+      !endif
+      !if "${MUI_HEADERIMAGE_UNBITMAP}" == ""
+        !error "Invalid MUI_HEADERIMAGE_UNBITMAP"
+      !endif
+
       !ifdef MUI_HEADERIMAGE_BITMAP_RTL
         !ifndef MUI_HEADERIMAGE_UNBITMAP_RTL
           !define MUI_HEADERIMAGE_UNBITMAP_RTL "${MUI_HEADERIMAGE_BITMAP_RTL}"
@@ -152,6 +161,13 @@
             !insertmacro MUI_SET MUI_HEADERIMAGE_UNBITMAP_RTL_NOSTRETCH
           !endif
         !endif
+
+        !if "${MUI_HEADERIMAGE_BITMAP_RTL}" == ""
+          !error "Invalid MUI_HEADERIMAGE_BITMAP_RTL"
+        !endif
+        !if "${MUI_HEADERIMAGE_UNBITMAP_RTL}" == ""
+          !error "Invalid MUI_HEADERIMAGE_UNBITMAP_RTL"
+        !endif
       !endif
 
     !endif
@@ -402,24 +418,24 @@
 
   !ifndef MUI_HEADER_TRANSPARENT_TEXT
 
-    SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     GetDlgItem $MUI_TEMP1 $HWNDPARENT 1038
-    SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
   !else
 
-    SetCtlColors $MUI_TEMP1 "" "transparent"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "transparent"
 
     GetDlgItem $MUI_TEMP1 $HWNDPARENT 1038
-    SetCtlColors $MUI_TEMP1 "" "transparent"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "transparent"
 
   !endif
 
-  GetDlgItem $MUI_TEMP1 $HWNDPARENT 1034
+  GetDlgItem $MUI_TEMP1 $HWNDPARENT 1034 ; Header background
   SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
 
-  GetDlgItem $MUI_TEMP1 $HWNDPARENT 1039
+  GetDlgItem $MUI_TEMP1 $HWNDPARENT 1039 ; Header image
   SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
 
   GetDlgItem $MUI_TEMP1 $HWNDPARENT 1028
@@ -694,6 +710,10 @@
 
 !macro MUI_PAGE_INIT
 
+  !ifdef MUI_INSERT
+    !warning "MUI_[UN]PAGE_* inserted after MUI_LANGUAGE"
+  !endif
+
   !insertmacro MUI_INTERFACE
 
   !insertmacro MUI_DEFAULT MUI_PAGE_UNINSTALLER_PREFIX ""
@@ -1104,6 +1124,10 @@
 
     UninstallText "${MUI_UNCONFIRMPAGE_TEXT_TOP}" "${MUI_UNCONFIRMPAGE_TEXT_LOCATION}"
 
+    !ifdef MUI_UNCONFIRMPAGE_VARIABLE
+      DirVar "${MUI_UNCONFIRMPAGE_VARIABLE}"
+    !endif
+
   PageExEnd
 
   !insertmacro MUI_UNFUNCTION_CONFIRMPAGE un.mui.ConfirmPre_${MUI_UNIQUEID} un.mui.ConfirmShow_${MUI_UNIQUEID} un.mui.ConfirmLeave_${MUI_UNIQUEID}
@@ -1261,16 +1285,16 @@
 
     !insertmacro INSTALLOPTIONS_INITDIALOG "ioSpecial.ini"
     Pop $MUI_HWND
-    SetCtlColors $MUI_HWND "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_HWND "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     GetDlgItem $MUI_TEMP1 $MUI_HWND 1201
-    SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     CreateFont $MUI_TEMP2 "$(^Font)" "12" "700"
     SendMessage $MUI_TEMP1 ${WM_SETFONT} $MUI_TEMP2 0
 
     GetDlgItem $MUI_TEMP1 $MUI_HWND 1202
-    SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
 
@@ -1371,9 +1395,10 @@
 
   Function "${SHOW}"
     !ifdef MUI_DIRECTORYPAGE_BGCOLOR
+      !insertmacro MUI_DEFAULT MUI_DIRECTORYPAGE_TEXTCOLOR ""
       FindWindow $MUI_TEMP1 "#32770" "" $HWNDPARENT
       GetDlgItem $MUI_TEMP1 $MUI_TEMP1 1019
-      SetCtlColors $MUI_TEMP1 "" "${MUI_DIRECTORYPAGE_BGCOLOR}"
+      SetCtlColors $MUI_TEMP1 "${MUI_DIRECTORYPAGE_TEXTCOLOR}" "${MUI_DIRECTORYPAGE_BGCOLOR}"
     !endif
     
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
@@ -1421,15 +1446,16 @@
   Pop $MUI_HWND
 
   !ifdef MUI_STARTMENUPAGE_BGCOLOR
+    !insertmacro MUI_DEFAULT MUI_STARTMENUPAGE_TEXTCOLOR ""
     GetDlgItem $MUI_TEMP1 $MUI_HWND 1002
-    SetCtlColors $MUI_TEMP1 "" "${MUI_STARTMENUPAGE_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_STARTMENUPAGE_TEXTCOLOR}" "${MUI_STARTMENUPAGE_BGCOLOR}"
     GetDlgItem $MUI_TEMP1 $MUI_HWND 1004
-    SetCtlColors $MUI_TEMP1 "" "${MUI_STARTMENUPAGE_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_STARTMENUPAGE_TEXTCOLOR}" "${MUI_STARTMENUPAGE_BGCOLOR}"
   !endif
 
   !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
-
   StartMenu::Show
+  !insertmacro MUI_PAGE_FUNCTION_CUSTOM DESTROYED
 
     Pop $MUI_TEMP1
     StrCmp $MUI_TEMP1 "success" 0 +2
@@ -1570,11 +1596,11 @@
           !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 5" "Bottom" "120"
         !endif
         !ifdef MUI_FINISHPAGE_REBOOTLATER_DEFAULT
-		  !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "State" "0"
+          !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "State" "0"
           !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 5" "State" "1"
         !else
           !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 4" "State" "1"
-		  !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 5" "State" "0"
+          !insertmacro INSTALLOPTIONS_WRITE "ioSpecial.ini" "Field 5" "State" "0"
         !endif
 
         Goto mui.finish_load
@@ -1739,26 +1765,26 @@
 
     !insertmacro INSTALLOPTIONS_INITDIALOG "ioSpecial.ini"
     Pop $MUI_HWND
-    SetCtlColors $MUI_HWND "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_HWND "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     GetDlgItem $MUI_TEMP1 $MUI_HWND 1201
-    SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     CreateFont $MUI_TEMP2 "$(^Font)" "12" "700"
     SendMessage $MUI_TEMP1 ${WM_SETFONT} $MUI_TEMP2 0
 
     GetDlgItem $MUI_TEMP1 $MUI_HWND 1202
-    SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+    SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     !ifndef MUI_FINISHPAGE_NOREBOOTSUPPORT
 
       IfRebootFlag 0 mui.finish_noreboot_show
 
         GetDlgItem $MUI_TEMP1 $MUI_HWND 1203
-        SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+        SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
         GetDlgItem $MUI_TEMP1 $MUI_HWND 1204
-        SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+        SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
         Goto mui.finish_show
 
@@ -1768,7 +1794,7 @@
 
     !ifdef MUI_FINISHPAGE_RUN
       GetDlgItem $MUI_TEMP1 $MUI_HWND 1203
-      SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+      SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
     !endif
 
     !ifdef MUI_FINISHPAGE_SHOWREADME
@@ -1777,7 +1803,7 @@
       !else
         GetDlgItem $MUI_TEMP1 $MUI_HWND 1204
       !endif
-      SetCtlColors $MUI_TEMP1 "" "${MUI_BGCOLOR}"
+      SetCtlColors $MUI_TEMP1 "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
     !endif
 
     !ifdef MUI_FINISHPAGE_LINK
@@ -1795,6 +1821,27 @@
       mui.finish_show:
     !endif
 
+    !ifndef MUI_FORCECLASSICCONTROLS
+    ${If} ${IsHighContrastModeActive}
+    !endif
+      ; SetCtlColors does not change the check/radio text color (bug #443)
+      !ifndef MUI_FINISHPAGE_NOREBOOTSUPPORT
+        GetDlgItem $MUI_TEMP1 $MUI_HWND 1203
+        System::Call 'UXTHEME::SetWindowTheme(p$MUI_TEMP1,w" ",w" ")'
+        GetDlgItem $MUI_TEMP1 $MUI_HWND 1204
+        System::Call 'UXTHEME::SetWindowTheme(p$MUI_TEMP1,w" ",w" ")'
+      !else ifdef MUI_FINISHPAGE_RUN | MUI_FINISHPAGE_SHOWREADME
+        GetDlgItem $MUI_TEMP1 $MUI_HWND 1203
+        System::Call 'UXTHEME::SetWindowTheme(p$MUI_TEMP1,w" ",w" ")'
+        !ifdef MUI_FINISHPAGE_RUN & MUI_FINISHPAGE_SHOWREADME
+        GetDlgItem $MUI_TEMP1 $MUI_HWND 1204
+        System::Call 'UXTHEME::SetWindowTheme(p$MUI_TEMP1,w" ",w" ")'
+        !endif
+      !endif
+    !ifndef MUI_FORCECLASSICCONTROLS
+    ${EndIf}
+    !endif
+
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
 
     !ifdef MUI_FINISHPAGE_CANCEL_ENABLED
@@ -2048,7 +2095,7 @@
   !verbose push
   !verbose ${MUI_VERBOSE}
 
-  ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
+  ReserveFile /plugin InstallOptions.dll
 
   !verbose pop
 
@@ -2059,7 +2106,7 @@
   !verbose push
   !verbose ${MUI_VERBOSE}
 
-  ReserveFile "${NSISDIR}\Plugins\LangDLL.dll"
+  ReserveFile /plugin LangDLL.dll
 
   !verbose pop
 
@@ -2068,40 +2115,35 @@
 ;--------------------------------
 ;LANGUAGES
 
-!macro MUI_LANGUAGE LANGUAGE
+!macro MUI_LANGUAGE NLFID
 
   ;Include a language
 
   !verbose push
   !verbose ${MUI_VERBOSE}
 
+  ; MUI_PAGE_UNINSTALLER_PREFIX is undefined by uninstaller pages so we check MUI_UNINSTALLER as well
+  !ifndef MUI_PAGE_UNINSTALLER_PREFIX && MUI_UNINSTALLER
+    !ifndef MUI_DISABLE_INSERT_LANGUAGE_AFTER_PAGES_WARNING ; Define this to avoid the warning if you only have custom pages
+      !warning "MUI_LANGUAGE should be inserted after the MUI_[UN]PAGE_* macros"
+    !endif
+  !endif
+
   !insertmacro MUI_INSERT
 
-  LoadLanguageFile "${NSISDIR}\Contrib\Language files\${LANGUAGE}.nlf"
+  LoadLanguageFile "${NSISDIR}\Contrib\Language files\${NLFID}.nlf"
 
   ;Include language file
-  !insertmacro LANGFILE_INCLUDE_WITHDEFAULT "${NSISDIR}\Contrib\Language files\${LANGUAGE}.nsh" "${NSISDIR}\Contrib\Language files\English.nsh"
+  !insertmacro LANGFILE_INCLUDE_WITHDEFAULT \
+    "${NSISDIR}\Contrib\Language files\${NLFID}.nsh" "${NSISDIR}\Contrib\Language files\English.nsh"
 
-  ;Add language to list of languages for selection dialog  
-  !ifndef MUI_LANGDLL_LANGUAGES
-    !define MUI_LANGDLL_LANGUAGES "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' "
-    !define MUI_LANGDLL_LANGUAGES_CP "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' '${LANG_${LANGUAGE}_CP}' "
-  !else
-    !ifdef MUI_LANGDLL_LANGUAGES_TEMP
-      !undef MUI_LANGDLL_LANGUAGES_TEMP
-    !endif
-    !define MUI_LANGDLL_LANGUAGES_TEMP "${MUI_LANGDLL_LANGUAGES}"
-    !undef MUI_LANGDLL_LANGUAGES
-
-	!ifdef MUI_LANGDLL_LANGUAGES_CP_TEMP
-      !undef MUI_LANGDLL_LANGUAGES_CP_TEMP
-    !endif
-    !define MUI_LANGDLL_LANGUAGES_CP_TEMP "${MUI_LANGDLL_LANGUAGES_CP}"
-    !undef MUI_LANGDLL_LANGUAGES_CP
-
-    !define MUI_LANGDLL_LANGUAGES "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' ${MUI_LANGDLL_LANGUAGES_TEMP}"
-    !define MUI_LANGDLL_LANGUAGES_CP "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' '${LANG_${LANGUAGE}_CP}' ${MUI_LANGDLL_LANGUAGES_CP_TEMP}"
-  !endif
+  ;Add language to list of languages for selection dialog
+  !define /ifndef MUI_LANGDLL_LANGUAGES ""
+  !define /redef MUI_LANGDLL_LANGUAGES \
+    `"${LANGFILE_${NLFID}_LANGDLL}" "${LANG_${NLFID}}" ${MUI_LANGDLL_LANGUAGES}`
+  !define /ifndef MUI_LANGDLL_LANGUAGES_CP ""
+  !define /redef MUI_LANGDLL_LANGUAGES_CP \
+    `"${LANGFILE_${NLFID}_LANGDLL}" "${LANG_${NLFID}}" "${LANG_${NLFID}_CP}" ${MUI_LANGDLL_LANGUAGES_CP}`
   
   !verbose pop
 
@@ -2115,6 +2157,10 @@
   !verbose push
   !verbose ${MUI_VERBOSE}
 
+  !ifndef MUI_LANGDLL_LANGUAGES
+    !warning "MUI_LANGDLL_DISPLAY should only be used after inserting the MUI_LANGUAGE macro(s)"
+  !endif
+
   !insertmacro MUI_DEFAULT MUI_LANGDLL_WINDOWTITLE "Installer Language"
   !insertmacro MUI_DEFAULT MUI_LANGDLL_INFO "Please select a language."
 
@@ -2172,7 +2218,8 @@
 
 !macro MUI_UNGETLANGUAGE
 
-  !verbose pop
+  !verbose push
+  !verbose ${MUI_VERBOSE}
 
   !ifdef MUI_LANGDLL_REGISTRY_ROOT & MUI_LANGDLL_REGISTRY_KEY & MUI_LANGDLL_REGISTRY_VALUENAME
 
@@ -2201,6 +2248,5 @@
 ;--------------------------------
 ;END
 
+!verbose pop
 !endif
-
-!verbose pop
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Localization.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Localization.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Localization.nsh	(revision 2956)
@@ -11,8 +11,8 @@
 !macro MUI_LANGDLL_VARIABLES
 
   !ifdef MUI_LANGDLL_REGISTRY_ROOT & MUI_LANGDLL_REGISTRY_KEY & MUI_LANGDLL_REGISTRY_VALUENAME
-    !ifndef MUI_LANGDLL_REGISTRY_VARAIBLES
-      !define MUI_LANGDLL_REGISTRY_VARAIBLES
+    !ifndef MUI_LANGDLL_REGISTRY_VARIABLES
+      !define MUI_LANGDLL_REGISTRY_VARIABLES
 
       ;/GLOBAL because the macros are included in a function
       Var /GLOBAL mui.LangDLL.RegistryLanguage
@@ -26,41 +26,43 @@
 ;--------------------------------
 ;Include langauge files
 
-!macro MUI_LANGUAGE LANGUAGE
+!macro MUI_LANGUAGEEX LangDir NLFID
 
-  ;Include a language
+  !verbose push ${MUI_VERBOSE}
 
-  !verbose push
-  !verbose ${MUI_VERBOSE}
+  !ifndef MUI_PAGE_UNINSTALLER_PREFIX
+    !ifndef MUI_DISABLE_INSERT_LANGUAGE_AFTER_PAGES_WARNING ; Define this to avoid the warning if you only have custom pages
+      !warning "MUI_LANGUAGE[EX] should be inserted after the MUI_[UN]PAGE_* macros"
+    !endif
+  !endif
 
   !insertmacro MUI_INSERT
 
-  LoadLanguageFile "${NSISDIR}\Contrib\Language files\${LANGUAGE}.nlf"
+  ;Include a language
+  LoadLanguageFile "${LangDir}\${NLFID}.nlf"
 
-  ;Include language file
-  !insertmacro LANGFILE_INCLUDE_WITHDEFAULT "${NSISDIR}\Contrib\Language files\${LANGUAGE}.nsh" "${NSISDIR}\Contrib\Language files\English.nsh"
+  ;Include MUI language file
+  !insertmacro LANGFILE_INCLUDE_WITHDEFAULT \
+    "${LangDir}\${NLFID}.nsh" "${NSISDIR}\Contrib\Language files\English.nsh"
 
   ;Add language to list of languages for selection dialog
-  !ifndef MUI_LANGDLL_LANGUAGES
-    !define MUI_LANGDLL_LANGUAGES "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' "
-    !define MUI_LANGDLL_LANGUAGES_CP "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' '${LANG_${LANGUAGE}_CP}' "
-  !else
-    !ifdef MUI_LANGDLL_LANGUAGES_TEMP
-      !undef MUI_LANGDLL_LANGUAGES_TEMP
-    !endif
-    !define MUI_LANGDLL_LANGUAGES_TEMP "${MUI_LANGDLL_LANGUAGES}"
-    !undef MUI_LANGDLL_LANGUAGES
+  !define /ifndef MUI_LANGDLL_LANGUAGES ""
+  !define /redef MUI_LANGDLL_LANGUAGES \
+    `"${LANGFILE_${NLFID}_LANGDLL}" "${LANG_${NLFID}}" ${MUI_LANGDLL_LANGUAGES}`
+  !define /ifndef MUI_LANGDLL_LANGUAGES_CP ""
+  !define /redef MUI_LANGDLL_LANGUAGES_CP \
+    `"${LANGFILE_${NLFID}_LANGDLL}" "${LANG_${NLFID}}" "${LANG_${NLFID}_CP}" ${MUI_LANGDLL_LANGUAGES_CP}`
 
-    !ifdef MUI_LANGDLL_LANGUAGES_CP_TEMP
-      !undef MUI_LANGDLL_LANGUAGES_CP_TEMP
-    !endif
-    !define MUI_LANGDLL_LANGUAGES_CP_TEMP "${MUI_LANGDLL_LANGUAGES_CP}"
-    !undef MUI_LANGDLL_LANGUAGES_CP
+  !verbose pop
 
-    !define MUI_LANGDLL_LANGUAGES "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' ${MUI_LANGDLL_LANGUAGES_TEMP}"
-    !define MUI_LANGDLL_LANGUAGES_CP "'${LANGFILE_${LANGUAGE}_NAME}' '${LANG_${LANGUAGE}}' '${LANG_${LANGUAGE}_CP}' ${MUI_LANGDLL_LANGUAGES_CP_TEMP}"
-  !endif
+!macroend
 
+!macro MUI_LANGUAGE NLFID
+
+  !verbose push ${MUI_VERBOSE}
+
+  !insertmacro MUI_LANGUAGEEX "${NSISDIR}\Contrib\Language files" "${NLFID}"
+
   !verbose pop
 
 !macroend
@@ -74,12 +76,16 @@
   !verbose push
   !verbose ${MUI_VERBOSE}
 
+  !ifndef MUI_LANGDLL_LANGUAGES
+    !warning "MUI_LANGDLL_DISPLAY should only be used after inserting the MUI_LANGUAGE macro(s)"
+  !endif
+
   !insertmacro MUI_LANGDLL_VARIABLES
 
   !insertmacro MUI_DEFAULT MUI_LANGDLL_WINDOWTITLE "Installer Language"
   !insertmacro MUI_DEFAULT MUI_LANGDLL_INFO "Please select a language."
 
-  !ifdef MUI_LANGDLL_REGISTRY_VARAIBLES
+  !ifdef MUI_LANGDLL_REGISTRY_VARIABLES
 
     ReadRegStr $mui.LangDLL.RegistryLanguage "${MUI_LANGDLL_REGISTRY_ROOT}" "${MUI_LANGDLL_REGISTRY_KEY}" "${MUI_LANGDLL_REGISTRY_VALUENAME}"
     
@@ -95,7 +101,7 @@
   !endif
 
   !ifndef MUI_LANGDLL_ALWAYSSHOW
-  !ifdef MUI_LANGDLL_REGISTRY_VARAIBLES
+  !ifdef MUI_LANGDLL_REGISTRY_VARIABLES
     ${if} $mui.LangDLL.RegistryLanguage == ""
   !endif
   !endif
@@ -113,7 +119,7 @@
     ${endif}
   
   !ifndef MUI_LANGDLL_ALWAYSSHOW
-  !ifdef MUI_LANGDLL_REGISTRY_VARAIBLES
+  !ifdef MUI_LANGDLL_REGISTRY_VARIABLES
     ${endif}
   !endif
   !endif
@@ -185,7 +191,7 @@
   !verbose push
   !verbose ${MUI_VERBOSE}
 
-  ReserveFile "${NSISDIR}\Plugins\LangDLL.dll"
+  ReserveFile /plugin LangDLL.dll
 
   !verbose pop
 
